## freefem++ 4.15+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(FreeFEM C CXX Fortran)

set(FREEFEM_VERSION 4.0)

# Add the path containing cmake modules
# Note: this line cannot be put in the body of ff_configure_cmake
# because ff_configure_cmake is searched in the right repository 
# thanks to this line
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake/modules)

include(ff_configure_cmake)
include(ff_configure_compilers)
include(ff_configure_thirdparty)
include(ff_write_config_file)

ff_configure_cmake()
ff_configure_compilers()
ff_configure_thirdparty()

ff_write_config_file()

# creation of "make test" command
# Note: this call MUST be performed in the main CMake script
enable_testing()

add_subdirectory(src)
add_subdirectory(examples)

=== plugin/CMakeLists.txt ===
#ADD_SUBDIRECTORY(mpi)
ADD_SUBDIRECTORY(seq)

=== src/CMakeLists.txt ===

include(ff_define_ffglut_executable)
include(ff_define_freefem_executable)
include(ff_define_freefem_mpi_executable)

# define the three executables:
# - ffglut
# - FreeFem++
# - FreeFem++-mpi

ff_define_ffglut_executable()
ff_define_freefem_executable()
ff_define_freefem_mpi_executable()


add_subdirectory(bamg)
add_subdirectory(bamglib)
add_subdirectory(fflib)
add_subdirectory(lglib)
add_subdirectory(libMesh)
add_subdirectory(medit)
add_subdirectory(mpi)

=== unit/Makefile ===
PARAM=-ne -fglut out -v 1000000

FF=../src/nw/FreeFem++
SRC=$(wildcard base/*.edp)

FFmpi=../src/mpi/ff-mpirun -np 4
SRCmpi=$(wildcard parallel/*.edp)

SRCplugins=$(wildcard plugins/*.edp)

.PHONY: all base parallel plugins

all: freefem++.pref base parallel plugins

freefem++.pref:
	echo loadpath += "../plugin/seq" > freefem++.pref
	echo loadpath += "../plugin/mpi" >> freefem++.pref
	echo includepath += "../idp" >> freefem++.pref

base:
	(for test in $(SRC); do \
		echo $$test; \
		$(FF) $$test $(PARAM) > $$test.log; \
		if [ "$$?" -eq "0" ]; then \
			echo -e "Success"; \
		else \
			echo -e "\tFail"; \
		fi \
	done)

parallel:
	(for test in $(SRCmpi); do \
		echo $$test; \
		$(FFmpi) $$test $(PARAM) > $$test.log; \
		if [ "$$?" -eq "0" ]; then \
			echo -e "Success"; \
		else \
			echo -e "\tFail"; \
		fi \
	done)

plugins:
	(for test in $(SRCplugins); do \
		echo $$test; \
		$(FF) $$test $(PARAM) > $$test.log; \
		if [ "$$?" -eq "0" ]; then \
			echo -e "Success"; \
		else \
			echo -e "\tFail"; \
		fi \
	done)

clean:
	rm -f base/*.log
	rm -f parallel/*.log
	rm -f plugins/*.log

=== 3rdparty/ff-petsc/Makefile ===
# ======================================================================
# Laboratoire Jacques-Louis Lions
# Université Pierre et Marie Curie-Paris6, UMR 7598, Paris, F-75005 France
# http://www.ljll.math.upmc.fr/lehyaric
# ======================================================================
# This file is part of Freefem++
#
# Freefem++ is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Freefem++ is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Freefem++; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
# ======================================================================
# headeralh default=0 freefem make multipleauthors start=19/03/10 upmc

include Makefile.inc

PYTHON ?=

DIR_INSTALL_REAL:=$(FF_prefix_petsc)/r
DIR_INSTALL_COMPLEX:=$(FF_prefix_petsc)/c
VERSION=$(shell grep "'petsc-" ../getall | perl -pe '($$_)=/([0-9]+([.][0-9]+)+)/')
PACKAGE=../pkg/petsc-$(VERSION).tar.gz
SRCDIR=petsc-$(VERSION)
PETSC_DIR:=$(shell pwd)/$(SRCDIR)
DARWIN=$(shell uname | grep Darwin 2> /dev/null)

W_SUDO:=$(SHELL mkdir -p "$(DESTDIR)$(FF_prefix_petsc)" && test -w "$(DESTDIR)$(FF_prefix_petsc) || echo sudo)
ifeq ($(COMPILE_OPENBLAS),openblas)
PETSC_OPENBLAS := --download-f2cblaslapack
PETSC_OPENBLAS_C := --with-blaslapack-dir=$(DIR_INSTALL_REAL)
else
PETSC_OPENBLAS = --with-blaslapack-include='$(shell echo $(BLASINC) | sed "s/-I//g")' \
		--with-blaslapack-lib='$(BLAS_LAPACK_LIBS)'
PETSC_OPENBLAS_C = $(PETSC_OPENBLAS)
endif
PETSC_DOWNLOAD_C := --with-metis-dir=$(DIR_INSTALL_REAL) \
		--with-ptscotch-dir=$(DIR_INSTALL_REAL) \
		--with-superlu-dir=$(DIR_INSTALL_REAL) \
		--with-suitesparse-dir=$(DIR_INSTALL_REAL) \
		--with-parmetis-dir=$(DIR_INSTALL_REAL) \
		--with-tetgen-dir=$(DIR_INSTALL_REAL)
PETSC_DOWNLOAD := --download-metis --download-ptscotch \
		--download-hypre --download-parmetis \
		--download-superlu --download-suitesparse --download-tetgen
ifneq ($(TOOL_DYLIB_mmg),)
PETSC_DOWNLOAD += --download-mmg
PETSC_DOWNLOAD_C += --with-mmg-dir=$(DIR_INSTALL_REAL)
ifneq ($(TOOL_DYLIB_parmmg),)
PETSC_DOWNLOAD += --download-parmmg
PETSC_DOWNLOAD_C += --with-parmmg-dir=$(DIR_INSTALL_REAL)
endif
endif
ifeq ($(FFCMAKE),no)
PETSC_DOWNLOAD := $(PETSC_DOWNLOAD) --download-cmake
endif
PETSC_DOWNLOAD_C := $(PETSC_DOWNLOAD_C) --download-htool --download-htool-commit=fe5e690b6e6fa1ca64f76bc1d0c602e07ed9715a
ifeq ($(FF_generic_petsc), yes)
FLAGS_MTUNE := -mtune=generic
endif
unexport MAKEFLAGS
COMMON_FLAGS := --with-debugging=0 COPTFLAGS='-O3 $(FLAGS_MTUNE)' CXXOPTFLAGS='-O3 $(FLAGS_MTUNE)' FOPTFLAGS='-O3 $(FLAGS_MTUNE)' --with-ssl=0 --with-x=0 --with-fortran-bindings=0 --with-cudac=0 --with-tau-perfstubs=0 \
		--download-slepc --download-hpddm

ifneq ($(wildcard ~/.petsc_pkg),)
COMMON_FLAGS += --with-packages-download-dir=~/.petsc_pkg
endif

ifeq ($(FC),)
COMMON_FLAGS += --with-fc=0
PETSC_DOWNLOAD += --download-superlu_dist
PETSC_DOWNLOAD_C += --with-superlu_dist-dir=$(DIR_INSTALL_REAL)
endif

ifeq ($(MPICC)$(MPICXX),)
ifeq ($(WIN32DLLTARGET),)
PETSC_DOWNLOAD += --with-cc='$(CC)' --with-cxx='$(CXX)' --download-mpich
PETSC_DOWNLOAD_C += --with-mpi-dir=$(DIR_INSTALL_REAL)
ifeq ($(DARWIN),Darwin)
PETSC_DOWNLOAD += --download-mpich-device=ch4:ofi 'LDFLAGS=-Wl,-ld_classic -Wl,-commons,use_dylibs'
endif
ifneq ($(FC),)
PETSC_DOWNLOAD += --with-fc='$(FC)'
endif
endif
else
COMMON_FLAGS += --with-cc='$(MPICC)' --with-cxx='$(MPICXX)'
ifneq ($(MPIFC),)
COMMON_FLAGS += --with-fc='$(MPIFC)'
endif
endif

ifeq ($(WIN32DLLTARGET),)
ifneq ($(FC),)
ifneq ($(wildcard ~/.petsc_pkg),)
PETSC_DOWNLOAD += --download-slepc-configure-arguments="--download-arpack --with-packages-download-dir=~/.petsc_pkg"
else
PETSC_DOWNLOAD += --download-slepc-configure-arguments="--download-arpack"
endif
endif
endif

ifneq ($(FC),)
ifneq ($(TOOL_DYLIB_scalapack)$(TOOL_DYLIB_mumps),)
PETSC_DOWNLOAD += --download-scalapack --download-mumps
PETSC_DOWNLOAD_C += --with-scalapack-dir=$(DIR_INSTALL_REAL) --with-mumps-dir=$(DIR_INSTALL_REAL)
else
PETSC_DOWNLOAD += --download-superlu_dist
PETSC_DOWNLOAD_C += --with-superlu_dist-dir=$(DIR_INSTALL_REAL)
endif
endif

ifneq ($(WIN32DLLTARGET),)
COMMON_FLAGS += --with-shared-libraries=0 \
	CXXFLAGS='-fno-stack-protector -Wno-stringop-overflow' \
	CFLAGS='-fno-stack-protector -Wno-stringop-overflow' \
	FFLAGS='$(FCFLAGS)' \
	--with-mpiexec='/C/Program\ Files/Microsoft\ MPI/Bin/mpiexec'
ifneq ($(FC),)
ifneq ($(wildcard ~/.petsc_pkg),)
PETSC_DOWNLOAD += '--download-slepc-configure-arguments=--with-packages-build-dir=$(PETSC_DIR)/fr/externalpackages --download-arpack --with-packages-download-dir=~/.petsc_pkg'
else
PETSC_DOWNLOAD += '--download-slepc-configure-arguments=--with-packages-build-dir=$(PETSC_DIR)/fr/externalpackages --download-arpack'
endif
endif
endif

FLAGS_CONF_PETSC_REAL = $(COMMON_FLAGS) --with-scalar-type=real $(PETSC_OPENBLAS) $(PETSC_DOWNLOAD)
FLAGS_CONF_PETSC_COMPLEX = $(COMMON_FLAGS) --with-scalar-type=complex $(PETSC_OPENBLAS_C) $(PETSC_DOWNLOAD_C)

all-local:
	@echo make ..
	@echo " # To build petsc and slepc do $ make petsc-slepc"
	@echo " # warning you have no write acces in $(DESTDIR)$(FF_prefix_petsc)"
	@echo " # need sudo if '$(W_SUDO)' == 'sudo' .."
	@echo " # run under root "
	@echo " # or create / add access to $(DESTDIR)$(FF_prefix_petsc) "
	@echo " # do for examples:"
	@echo " # PETSC_DOWNLOAD = $(PETSC_DOWNLOAD)"
	@echo "	sudo mkdir $(DESTDIR)$(FF_prefix_petsc)"
	@echo "	sudo chown -R $(LOGNAME) $(DESTDIR)$(FF_prefix_petsc)"
	@echo "	make petsc-slepc "

MPI_DIR:=$(shell dirname "$(MPI_INC_DIR)")
SUDO_WITH_ENV=$(if $(SUDO), $(SUDO) -E)
ifeq ($(LAPACKLIBS), $(BLASLIBS))
  BLAS_LAPACK_LIBS=$(LAPACKLIBS)
else
  BLAS_LAPACK_LIBS=$(LAPACKLIBS) $(BLASLIBS)
endif

petsc-slepc: Makefile.inc dir-install WHERE-all
recompile: recompile-real recompile-complex
recompile-real:
	-rm */tag-make-real
	-rm */tag-install-real
	make WHERE
recompile-complex:
	-rm */tag-make-complex
	-rm */tag-install-complex
	@if [ -n "$(MPI_INCLUDE)" ]; then $(MAKE) -f Makefile.complex WHERE-complex ;\
	else echo " -- No PETSc, no MPI"; fi

dir-install: Makefile.inc
	-$(SUDO) mkdir -p $(DESTDIR)$(DIR_INSTALL_REAL)
	-$(SUDO) chown ${USER} $(DESTDIR)$(DIR_INSTALL_REAL)
	-$(SUDO) mkdir -p $(DESTDIR)$(DIR_INSTALL_COMPLEX)
	-$(SUDO) chown ${USER} $(DESTDIR)$(DIR_INSTALL_COMPLEX)
	@if test -w 	"$(DESTDIR)$(DIR_INSTALL_REAL)" -a -w 	"$(DESTDIR)$(DIR_INSTALL_COMPLEX)" ; then echo "no need of sudo"; echo > do-sudo; \
	else \
	 echo no write access in $(DESTDIR)$(DIR_INSTALL_REAL) and $(DESTDIR)$(DIR_INSTALL_COMPLEX); \
	 echo " do: make petsc-slepc SUDO=sudo "; \
	 echo " or add write access to 2 directory "; \
	 echo sudo >do-sudo; \
	fi
	test -e "$(DESTDIR)$(DIR_INSTALL_REAL)" -a -e "$(DESTDIR)$(DIR_INSTALL_COMPLEX)"
PETSc-real:
	@if [ -n "$(MPI_INCLUDE)" ]; then $(MAKE) WHERE ;\
	else echo " -- No PETSc, no MPI"; fi

PETSc-complex:
	@if [ -n "$(MPI_INCLUDE)" ]; then $(MAKE) -f Makefile.complex WHERE-complex ;\
	else echo " -- No PETSc, no MPI, no PETSc real"; fi

WHERE:../lib/WHERE.PETSc ../lib/WHERE.SLEPc

../lib/WHERE.PETSc:$(SRCDIR)/tag-install-real
	-mkdir ../lib
	echo 'petsc LD -Wl,-rpath,"$(DIR_INSTALL_REAL)/lib" -L"$(DIR_INSTALL_REAL)/lib" -lpetsc' > $@
	echo 'petsc INCLUDE -I"$(DIR_INSTALL_REAL)/include"' >> $@

$(SRCDIR)/tag-make-real:$(SRCDIR)/tag-conf-real
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fr all
	touch $@


$(SRCDIR)/tag-install-real :$(SRCDIR)/tag-make-real
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fr install-lib
	-cd $(SRCDIR) && export HWLOC_HIDE_ERRORS=2 && $(MAKE) PETSC_DIR=$(DIR_INSTALL_REAL) SLEPC_DIR=$(DIR_INSTALL_REAL) PETSC_ARCH="" check
	test -e $(DIR_INSTALL_REAL)/include/petsc.h
	test -e $(DIR_INSTALL_REAL)/lib/petsc/conf/petscvariables
	touch $@

Makefile.inc:../../config.status Makefile Makefile-PETSc.inc
	../../config.status --file="Makefile.inc:Makefile-PETSc.inc"

$(SRCDIR)/tag-conf-real:$(SRCDIR)/tag-tar
	cd $(SRCDIR) && $(PYTHON) ./configure --prefix=$(DIR_INSTALL_REAL) \
		$(FLAGS_CONF_PETSC_REAL) PETSC_ARCH=fr
	test -f $(SRCDIR)/fr/lib/petsc/conf/petscvariables
	mkdir -p $(SRCDIR)/fc/externalpackages || true
	cp -r $(SRCDIR)/fr/externalpackages/git.slepc $(SRCDIR)/fr/externalpackages/git.hpddm $(SRCDIR)/fc/externalpackages || true
	touch $@
Make-petsc-download.mk:$(SRCDIR)/tag-install-real
	test -e $(DIR_INSTALL_REAL)/lib/petsc/conf/petscvariables
	egrep 'PETSC_LIB_BASIC|SCALAPACK_|METIS_|MUMPS_|HPDDM_|HTOOL_|TETGEN_|SUPERLU_|MMG_|PTSCOTCH_|SUITESPARSE_' $(DIR_INSTALL_REAL)/lib/petsc/conf/petscvariables | sed 's/-I/ /g'|sort >$@
ifdef 	COMPLEX_CASE
#  version COMPLEX.....
$(SRCDIR)/tag-conf-complex:$(SRCDIR)/tag-tar Make-petsc-download.mk
	cd $(SRCDIR) && $(PYTHON) ./configure --prefix=$(DIR_INSTALL_COMPLEX) \
		$(FLAGS_CONF_PETSC_COMPLEX) PETSC_ARCH=fc
	test -f $(SRCDIR)/fc/lib/petsc/conf/petscvariables
	touch $@

$(SRCDIR)/tag-make-complex:$(SRCDIR)/tag-conf-complex Make-petsc-download.mk
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fc all
	touch $@

$(SRCDIR)/tag-install-complex :$(SRCDIR)/tag-make-complex
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fc install-lib
	test -e $(DIR_INSTALL_COMPLEX)/include/petsc.h
	touch $@
WHERE-complex:../lib/WHERE.PETSc-complex ../lib/WHERE.SLEPc-complex

../lib/WHERE.PETSc-complex:$(SRCDIR)/tag-install-complex
	test -e $(DIR_INSTALL_COMPLEX)/include/petsc.h
	-mkdir ../lib
	echo 'petsccomplex LD -Wl,-rpath,"$(DIR_INSTALL_COMPLEX)/lib" -L"$(DIR_INSTALL_COMPLEX)/lib" -lpetsc' > $@
	echo 'petsccomplex INCLUDE -I"$(DIR_INSTALL_COMPLEX)/include"' >> $@
	echo done $@
../lib/WHERE.SLEPc-complex:
	test -e $(DIR_INSTALL_COMPLEX)/include/slepc.h
	-mkdir ../lib
	echo 'slepccomplex LD -Wl,-rpath,"$(DIR_INSTALL_COMPLEX)/lib" -L"$(DIR_INSTALL_COMPLEX)/lib" -lslepc' > $@
	echo 'slepccomplex INCLUDE -I"$(DIR_INSTALL_COMPLEX)/include"' >> $@
	echo done $@

WHERE-all:Makefile WHERE WHERE-complex
	echo >$@
	test -z '$(SCALAPACK_LIB)' || echo scalapack LD $(SCALAPACK_LIB) >>$@
	test -z '$(SCALAPACK_INCLUDE)' || echo scalapack INCLUDE -I$(SCALAPACK_INCLUDE) >>$@
	test -z '$(METIS_LIB)' || echo metis LD $(METIS_LIB) >>$@
	test -z '$(METIS_INCLUDE)' || echo metis INCLUDE -I$(METIS_INCLUDE) >>$@
	test -z '$(MUMPS_LIB)' || echo mumps LD $(MUMPS_LIB) >>$@
	test -z '$(MUMPS_INCLUDE)' || echo mumps INCLUDE -I$(MUMPS_INCLUDE) >>$@
	test -z '$(SUPERLU_LIB)' || echo superlu LD $(SUPERLU_LIB) >>$@
	test -z '$(SUPERLU_INCLUDE)' || echo superlu INCLUDE -I$(SUPERLU_INCLUDE) >>$@
	test -z '$(MMG_LIB)' || echo mmg LD $(MMG_LIB) >>$@
	test -z '$(MMG_INCLUDE)' || echo mmg INCLUDE -I$(MMG_INCLUDE) >>$@
	test -z '$(PARMMG_LIB)' || echo parmmg LD $(PARMMG_LIB) >>$@
	test -z '$(PARMMG_INCLUDE)' || echo parmmg INCLUDE -I$(PARMMG_INCLUDE) >>$@
	test -z '$(PTSCOTCH_LIB)' || echo ptscotch LD $(PTSCOTCH_LIB) >>$@
	test -z '$(PTSCOTCH_INCLUDE)' || echo ptscotch INCLUDE -I$(PTSCOTCH_INCLUDE) >>$@
	test -z '$(TETGEN_LIB)' || echo tetgen LD $(TETGEN_LIB) >>$@
	test -z '$(TETGEN_INCLUDE)' || echo tetgen INCLUDE -I$(TETGEN_INCLUDE) >>$@
	test -z '$(PARMETIS_LIB)' || echo parmetis LD $(PARMETIS_LIB) >>$@
	test -z '$(PARMETIS_INCLUDE)' || echo parmetis INCLUDE -I$(PARMETIS_INCLUDE) >>$@
	test -z '$(HPDDM_LIB)' || echo hpddm LD $(HPDDM_LIB) >>$@
	test -z '$(HPDDM_INCLUDE)' || echo hpddm INCLUDE -I$(HPDDM_INCLUDE) >>$@
	test -z '$(HTOOL_LIB)' || echo htool LD $(HTOOL_LIB) >>$@
	test -z '$(HTOOL_INCLUDE)' || echo htool INCLUDE -I$(HTOOL_INCLUDE) >>$@

=== 3rdparty/libpthread-google/Makefile ===
include ff-flags
PACKAGE=../pkg/libpthread-google.tar.gz
SRCDIR= ./libpthread-google
libpthread-google: WHERE

ifeq ($(WIN32DLLTARGET),)
libpthread-google WHERE tag-install tag-tar $(PACKAGE):
	@echo "	Warning:not under windows do nothing, target: $@" 
else

libpthread-google: WHERE
	
WHERE:tag-install
		echo pthread-google  LD -L@DIR@/lib -lpthread-google  >../lib/WHERE.pthread-google
		echo pthread-google INCLUDE -I@DIR@/include/pthread-google >> ../lib/WHERE.pthread-google

tag-install:tag-tar
	cd $(SRCDIR)/src; \
	$(CC) -O -c *.c -I../include ;\
	$(AR) rcs ../../../lib/libpthread-google.a *.o 
	
	cp -r $(SRCDIR)/include/.  ../include/pthread-google
	touch $@

tag-tar: $(PACKAGE)
	tar zxvf  $(PACKAGE)
	touch $@
	
$(PACKAGE):
	../getall -o libpthread-google -a
	
endif
clean:
		-rm ff-flags tag-*
		-rm -rf libpthread-google*
		-rm FAIT $(FAIRE) 
		-rm ../lib/*pthread-google*
		-rm -rf ../include/pthread-google*


ff-flags: ../Makefile Makefile
	grep 'abs_top_builddir *=' ../Makefile > ff-flags
	grep 'CC *=' ../Makefile >> ff-flags
	grep 'CFLAGS *=' ../Makefile >> ff-flags
	grep 'LDFLAGS *=' ../Makefile >> ff-flags
	grep 'AR *=' ../Makefile >> ff-flags
	grep 'ARFLAGS *=' ../Makefile >> ff-flags
	grep 'RANLIB *=' ../Makefile >> ff-flags
	grep 'WIN32DLLTARGET *=' ../Makefile >> ff-flags
	grep 'WGET *=' ../Makefile >> ff-flags
	grep 'LIBS *=' ../Makefile >> ff-flags

=== 3rdparty/metis/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

include Makefile.in

all-local: metis

# Downloading and compiling Tetgen
# ------------------------------
# http://glaros.dtc.umn.edu/gkhome/fetch/sw/metis/metis-4.0.tar.gz
# Metis information
DIRPKG=../pkg
SRCDIR=metis-$(metis_VERSION)
PACKAGE=$(DIRPKG)/metis-$(metis_VERSION).tar.gz
SERVER=http://glaros.dtc.umn.edu/gkhome/fetch/sw/metis
#//http://glaros.dtc.umn.edu/gkhome/fetch/sw/metis/OLD
INSTALL=../..

# FFCS - 14/11/11 - version 4.0.3 is not available from netlib anymore
metis_VERSION=5.1.0

metis: FAIRE


$(SRCDIR)/FAIT:
	$(MAKE) install
	touch $(SRCDIR)/FAIT

install:$(SRCDIR)/tag-compile
#	cd $(SRCDIR)/Programs ;$(MAKE)
#	cd $(SRCDIR) ;  $(MAKE)  -C  install
	-mkdir -p ../include
	-mkdir -p ../lib
	cp $(SRCDIR)/libmetis.a ../lib
	cp $(SRCDIR)/include/*.h ../include


FAIRE: $(SRCDIR)/FAIT
	$(MAKE) WHERE
	touch FAIRE

Makefile.in: ../../config.status Makefile-metis.in
	../../config.status  --file="Makefile.in:Makefile-metis.in"

$(SRCDIR)/tag-compile: $(SRCDIR)/tags
	#cd $(SRCDIR)/libmetis ;
	make -C $(SRCDIR)/libmetis $(OBJS) 'CC=$(CC)' CFLAGS='$(CFLAGS) -I../GKlib -I../include  -I.'
	make -C $(SRCDIR)/GKlib $(OBJS_GK) 'CC=$(CC)' CFLAGS='$(CFLAGS) -I../GKlib -I../include  -I. -Dmetis_EXPORTS -D_GNU_SOURCE'
	mkdir $(SRCDIR)/lib
	cd $(SRCDIR); $(AR)  libmetis.a  libmetis/*.o GKlib/*.o
	touch $(SRCDIR)/tag-compile



WHERE:
	-if [ -f $(SRCDIR)/FAIT ] ; then \
	echo metis LD -L@DIR@/lib -lmetis  >$(SRCDIR)/$(INSTALL)/lib/WHERE.metis ;\
	echo metis INCLUDE -I@DIR@/include >> $(SRCDIR)/$(INSTALL)/lib/WHERE.metis ;\
	fi


OBJS=auxapi.o	coarsen.o	fm.o		graph.o	kwayrefine.o	minconn.o	options.o	separator.o	timing.o \
balance.o	compress.o	fortran.o	initpart.o	mcutil.o	mincover.o	parmetis.o	sfm.o		util.o \
bucketsort.o	contig.o	frename.o	kmetis.o	mesh.o	mmd.o		pmetis.o	srefine.o	wspace.o \
checkgraph.o	debug.o	gklib.o	kwayfm.o	meshpart.o	ometis.o	refine.o	stat.o

OBJS_GK=b64.o		error.o	fs.o		graph.o	itemsets.o	omp.o		random.o	sort.o	tokenizer.o \
blas.o	evaluate.o	getopt.o	htable.o	mcore.o	pdb.o		rw.o		string.o	util.o \
csr.o		fkvkselect.o	gkregex.o	io.o		memory.o	pqueue.o	seq.o		timers.o



# FFCS: patch is necessary for metis 4.0, but not for 4.0.3
$(SRCDIR)/tags: $(PACKAGE)
	tar xzf $(PACKAGE)
	patch -p0  <metis-5.1.patch
	touch $(SRCDIR)/tags

$(PACKAGE):
	../getall -o METIS -a

clean-local:
	-cd $(SRCDIR) && $(MAKE) realclean  -C $(SRCDIR)
	-rm -rf config.log ../lib/metis ../lib/WHERE.metis
# remove metis if no parmetis 
	-test -f ../lib/libparmetis.a || rm ../lib/libmetis.a 
	-test -f ../include/parmetis.h || rm ../include/metis.h
	-rm -rf ../include/metis
	-rm -rf $(SRCDIR)
	-rm FAIRE FAIT

# FFCS - 23/5/12 - $(SRCDIR)/$(INSTALL) is meaningless if $(SRCDIR) does not exist
clean: clean-local

=== 3rdparty/mmg/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

all-local: mmg

include ff-flags

# Downloading and compiling mmg
# -------------------------------
#
DIRPKG= ../pkg
SRCDIR= .
PACKAGE=$(DIRPKG)/mmg.zip
INSTALL=.
mmg_VERSION=

mmg:WHERE.done

ifeq ($(WIN32DLLTARGET),)
CMAKE_GENERATOR := 
else
CMAKE_GENERATOR := -G "MSYS Makefiles"
endif

FAIT.done:tag-tar
	-mkdir build
	cd build && cmake ../mmg-sources \
	-DMMG_INSTALL_PRIVATE_HEADERS=1 \
	-DCMAKE_C_COMPILER=$(CC) \
	-DCMAKE_C_FLAGS="$(CFLAGS) -fPIC" \
	-DCMAKE_CXX_COMPILER="$(CXX)" \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CXX11FLAGS) -fPIC" \
	-DM_LIB="-lm" -DUSE_ELAS=OFF -DUSE_VTK=OFF \
	-DSCOTCH_DIR=$(scotch_dir) \
	-DCMAKE_BUILD_TYPE=Release $(CMAKE_GENERATOR) && $(MAKE)
	touch FAIT.done

install.done:FAIT.done
	cp -r build/include/mmg ../include/mmg
	cp build/lib/libmmg.a ../lib
	touch $@

mmg:$(PACKAGE)

install:install.done WHERE.done

WHERE.done: install.done
	echo mmg LD -L@DIR@/lib -lmmg >../lib/WHERE.mmg ;
	echo mmg INCLUDE -I@DIR@/include/>> ../lib/WHERE.mmg ;
	echo build WHERE ./lib/WHERE.mmg ;
	touch $@
clean::
	-rm WHERE.done

FAIRE: FAIT.done install.done

tag-tar: $(PACKAGE)
	-rm -rf mmg-*
	unzip -q $(PACKAGE) && mv mmg-* mmg-sources
#	patch -p1 <patch-mmg 
	touch tag-tar

$(PACKAGE): FORCE
	../getall -o mmg -a

FORCE:

clean::
	-rm ff-flags *.done 
	-rm FAIT* 
	-rm -rf mmg-* build
	-rm flags-* tag-tar*
	-rm -rf ../include/mmg
	-rm ../lib/libmmg.a

ff-flags: ../Makefile Makefile ../getall
	../getall -o mmg -a
	-cp -f ff-flags ff-flags.old
	grep 'abs_top_builddir *=' ../Makefile > ff-flags
	grep 'CC *=' ../Makefile >> ff-flags
	grep 'CFLAGS *=' ../Makefile >> ff-flags
	grep 'CXX *=' ../Makefile >> ff-flags
	grep 'CXXFLAGS *=' ../Makefile >> ff-flags
	grep 'CXX11FLAGS *=' ../Makefile >> ff-flags
	grep 'LDFLAGS *=' ../Makefile >> ff-flags
	grep 'AR *=' ../Makefile >> ff-flags
	grep 'ARFLAGS *=' ../Makefile >> ff-flags
	grep 'RANLIB *=' ../Makefile >> ff-flags
	grep 'WGET *=' ../Makefile >> ff-flags
	grep 'STD_LIBS *=' ../Makefile >> ff-flags
	grep 'CNOFLAGS *=' ../Makefile >> ff-flags
	grep 'WIN32DLLTARGET *=' ../Makefile >> ff-flags
	grep 'FF_prefix_petsc_real *=' ../Makefile >> ff-flags
	-awk '/^scotch LD /&&/petsc/ {print "scotch_dir=$$(FF_prefix_petsc_real)" }' ../../plugin/seq/WHERE_LIBRARY-config >> ff-flags
	-awk '/^scotch LD /{print "scotch_dir=../../../3rdparty/" }' ../lib/WHERE.scotch >> ff-flags
	../../bin/ff-md5 $(PACKAGE) >> ff-flags	
	if diff -q ff-flags ff-flags.old ; then echo No Modif skip compile of mmg ; else touch -c tag-tar; fi

.PHONY:$(SRCDIR)/$(INSTALL)

=== 3rdparty/mmg3d/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

all-local: mmg3d

include ff-flags

# Downloading and compiling mmg3d
# -------------------------------
#
DIRPKG= ../pkg
SRCDIR= ./mmg3d4
PACKAGE=$(DIRPKG)/mmg3d4.0.tgz
INSTALL=..
mmg3d_VERSION=
# mmg3d pas sur internet
LIBMMG3D=$(INSTALL)/lib/libmmg3d-v4.a
OPT=4
# size of the PKG file ( this file change See Cecile.) FFCS - 19/2/13 - the test for the file size (`stat -f "%z" file`)
# is not portable from MacOS, so just leave it out in FFCS (SIZEPKG is still useful to force a remake when the package
# changes)
SIZEPKG=158547

OBJS= analar.o	chkmsh.o	hash.o		memory.o	optcte.o	outqua.o	simu44.o	swap44.o	zaldy.o \
analarcutting.o	chrono.o	heap.o		mmg3d1.o	optlap.o	pattern.o	simu56.o	swap56.o \
baryct.o	colpoi.o	inout.o		mmg3d4.o	optlen.o	quality.o	simu68.o	swap68.o \
boulep.o	coquil.o	length.o	mmg3d9.o	optlentet.o	queue.o		simu710.o	swap710.o \
bucket.o	cutelt.o	librnbg.o	movevertex.o	optra4.o	ratio.o		solmap.o	swapar.o \
		delaunay.o	locate.o	optbdry.o	opttet.o	scalem.o	spledg.o	swaptet.o \
cenrad.o	eigenv.o	matrix.o	optcoq.o	opttyp.o	simu23.o	swap23.o	typelt.o

OBJSNOP =  cendel.o swapar.o

# FFCS - simplify Makefile structure
mmg3d:WHERE.done

mmg3d4/FAIT-4.done:tag-tar-$(SIZEPKG)
	echo "#define COMPIL " '"' `date` '"' > ./mmg3d4/build/sources/compil.date
	cd mmg3d4/build/sources/; $(MAKE) CC='$(CC)' CFLAGS='$(CNOFLAGS) -g'   $(OBJSNOP)
	cd mmg3d4/build/sources/; $(MAKE) CC='$(CC)' CFLAGS='$(CFLAGS) -g'   $(OBJS)
	cd mmg3d4/build/sources/mmg3dmain; $(CC) -c $(CFLAGS)   mmg3d.c -I..
	$(AR) $(ARFLAGS) $(LIBMMG3D) mmg3d4/build/sources/*.o mmg3d4/build/sources/mmg3dmain/mmg3d.o
#
#	FFCS - ranlib required on Windows 7 64 bits
#
	$(RANLIB) $(LIBMMG3D)
	-$(CC) $(CNOFLAGS) mmg3d4/build/sources/mmg3dmain/mmg3d.o   mmg3d4/build/sources/*.o -o ../bin/mmg3d $(STD_LIBS)
	touch mmg3d4/FAIT-4.done

# FFCS - simplify Makefile structure
install-4.done:mmg3d4/FAIT-4.done
	-mkdir ../include/mmg3d-v4/
	cp mmg3d4/build/sources/*.h ../include/mmg3d-v4/
	touch $@
clean::
	-rm install-4.done

mmg3d-4:$(PACKAGE)

install:install-4.done WHERE.done

# FFCS - keep simplest makefile structure for automatic recompilations
WHERE.done: install-4.done
	echo mmg3d-v4  LD -L@DIR@/lib -lmmg3d-v4  >../lib/WHERE.mmg3d ;
	echo mmg3d-v4 INCLUDE -I@DIR@/include/mmg3d-v4>> ../lib/WHERE.mmg3d ;
	echo build WHERE ./lib/WHERE.mmg3d ;
	touch $@
clean::
	-rm WHERE.done

FAIRE: mmg3d4/FAIT-4.done install-4.done

# FFCS - keep it simple
tag-tar-$(SIZEPKG): $(PACKAGE) patch-mmg3dv4.diff
	-rm -rf  mmg3d4
	tar xzf $(PACKAGE)
	-rm mmg3d4/build/libexamples/main.
	touch mmg3d4/build/sources/dataff.h
#
#	ALH - clean-up all CR/LF to make patching more successful
#
	../../bin/build/cleancrlf mmg3d4
#
	cd mmg3d4;patch -p1 <../patch-mmg3dv4.diff
	cat </dev/null >mmg3d4/build/sources/mmg3dConfig.h
	touch tag-tar-$(SIZEPKG)
#	cp makefile-mmg3d.inc $(SRCDIR)/makefile

$(PACKAGE):
	../getall -o MMG3D -a

clean::
	-rm ff-flags
#
#	FFCS - make sure that all directories are cleaned. Thisis especially important under Windows because there is no
#	compilation dependencies control there (see
#	[[file:c:/cygwin/home/alh/ffcs/dist/configure.ac::dependency_tracking]])
#
	-rm -r mmg3d4
	-rm FAIT* mmg* flags-* tag-tar*
#FH 	-rm $(PACKAGE)

ff-flags: ../Makefile Makefile
	grep 'abs_top_builddir *=' ../Makefile > ff-flags
	grep 'CC *=' ../Makefile >> ff-flags
	grep 'CFLAGS *=' ../Makefile >> ff-flags
	grep 'LDFLAGS *=' ../Makefile >> ff-flags
	grep 'AR *=' ../Makefile >> ff-flags
	grep 'ARFLAGS *=' ../Makefile >> ff-flags
	grep 'RANLIB *=' ../Makefile >> ff-flags
	grep 'WGET *=' ../Makefile >> ff-flags
	grep 'STD_LIBS *=' ../Makefile >> ff-flags
	grep 'CNOFLAGS *=' ../Makefile >> ff-flags
.PHONY:$(SRCDIR)/$(INSTALL)

=== 3rdparty/mshmet/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

all-local: mshmet

include ff-flags

# Now in distrib  and compiling mshmet
# -------------------------------
# 
DIRPKG= ../pkg
SRCDIR= ./src
#-$(mshmet_VERSION)
INSTALL=../..
mshmet_VERSION=.FH
FAIRE=$(SRCDIR)/FAIRE

# ---------------------- 
#     mshmetlib

MSHMET_DIR = $(abs_top_builddir)/3rdparty/mshmet/src
MSHMET_SRCDIR = $(MSHMET_DIR)/sourceslib
MSHMET_OBJDIR = $(MSHMET_DIR)/objects

mshmet: $(FAIRE) 

$(FAIRE):$(SRCDIR)/FAIT
	$(MAKE) WHERE $(SRCDIR)/$(INSTALL)  
	touch $(FAIRE)

$(SRCDIR)/FAIT:$(SRCDIR)/tag-tar
	cd $(MSHMET_DIR); $(MAKE)
	touch $(SRCDIR)/FAIT

# FFCS - libMesh is also required by yams, so we move all the rules to [[file:../../../Makefile.am]]
install:$(SRCDIR)/FAIT
	cp $(MSHMET_SRCDIR)/mshmetlib.h  $(SRCDIR)/$(INSTALL)/include/mshmetlib.h
	cp $(MSHMET_OBJDIR)/libmshmet.a  $(SRCDIR)/$(INSTALL)/lib/libmshmet.a

# FFCS - simplify makefile structure for automatic rebuilds
WHERE:install
	echo mshmet  LD -L@DIR@/lib -lmshmet  >$(SRCDIR)/$(INSTALL)/lib/WHERE.mshmet
	echo mshmet INCLUDE -I@DIR@/include>> $(SRCDIR)/$(INSTALL)/lib/WHERE.mshmet


$(SRCDIR)/tag-tar:
	touch $(SRCDIR)/tag-tar


clean:
	-rm ff-flags
#	FFCS - make sure that all directories are cleaned. Thisis especially important under Windows because there is no
#	compilation dependencies control there (see
#	[[file:c:/cygwin/home/alh/ffcs/dist/configure.ac::dependency_tracking]])
	-rm -rf mshmet.????.??.??
	-rm FAIT $(FAIRE) 

ff-flags: ../Makefile 
	grep 'abs_top_builddir *=' ../Makefile >> ff-flags
	grep 'CC *=' ../Makefile >> ff-flags
	grep 'CFLAGS *=' ../Makefile >> ff-flags
	grep 'LDFLAGS *=' ../Makefile >> ff-flags
	grep 'AR *=' ../Makefile >> ff-flags
	grep 'ARFLAGS *=' ../Makefile >> ff-flags
	grep 'RANLIB *=' ../Makefile >> ff-flags
	grep 'WGET *=' ../Makefile >> ff-flags


.PHONY: $(SRCDIR)/$(INSTALL)

=== 3rdparty/mumps-seq/Makefile ===
# ======================================================================
# Laboratoire Jacques-Louis Lions
# Université Pierre et Marie Curie-Paris6, UMR 7598, Paris, F-75005 France
# http://www.ljll.math.upmc.fr/lehyaric
# ======================================================================
# This file is part of Freefem++
# 
# Freefem++ is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
# 
# Freefem++ is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with Freefem++; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
# ======================================================================
# headeralh default=0 freefem make multipleauthors start=19/03/10 upmc

# Downloading and compiling extra libraries
# -----------------------------------------

include Makefile.inc

all-local: mumps
mumps:../lib/WHERE.mumpsseq

# Downloading and compiling mumps
# -------------------------------

DIRPKG=../pkg
SRCDIR=MUMPS_$(VERSION)
PACKAGE1=$(DIRPKG)/MUMPS_$(VERSION).tar.gz
INSTALL=../..
VERSION=5.0.2

# FFCS - install and WHERE need to be done sequentially, even in parallel builds

../lib/WHERE.mumpsseq: install.done
	echo mumps_seq LD -L@DIR@/lib -ldmumpsFREEFEM-SEQ -lzmumpsFREEFEM-SEQ -lmumps_commonFREEFEM-SEQ	\
		-lpordFREEFEM-SEQ $(LIBSPTHREAD)  > ../lib/WHERE.mumpsseq
	echo mumps_seq INCLUDE -I@DIR@/include/mumps_seq >> ../lib/WHERE.mumpsseq
	echo libseq LD -L@DIR@/lib  -lmpiseqFREEFEM-SEQ >>../lib/WHERE.mumpsseq
	echo libseq INCLUDE -I@DIR@/include -I@DIR@/include/mumps_seq >> ../lib/WHERE.mumpsseq

install.done: $(SRCDIR)/FAIT
	-mkdir -p ../include/mumps_seq
	cp $(SRCDIR)/include/*.h ../include/mumps_seq
	cp $(SRCDIR)/libseq/*.h  ../include/mumps_seq
	-mkdir -p ../lib
	cp $(SRCDIR)/lib/*.a ../lib/
	cp $(SRCDIR)/libseq/libmpiseqFREEFEM-SEQ.a ../lib/
	touch $@

$(SRCDIR)/FAIT:Makefile.inc $(SRCDIR)/tag-tar
	cp Makefile.inc $(SRCDIR)
#
#	FFCS - 22/5/12 - Mumps has difficulties compiling d & z in parallel
#
	cd $(SRCDIR) && $(MAKE) d
	cd $(SRCDIR) && $(MAKE) z
	touch $@

Makefile.inc: ../../config.status Makefile Makefile-mumps-$(VERSION).inc
	../../config.status  --file="Makefile.inc:Makefile-mumps-$(VERSION).inc"

$(SRCDIR)/tag-tar:$(PACKAGE1)
	tar xzf $(PACKAGE1)
	touch $@

$(PACKAGE1):
	../getall -o MUMPS -a

clean:
	-rm Makefile.inc FAIRE* *~ 
	-rm -rf ../include/*mumps*
	-rm -rf ../lib/lib*mumps*SEQ* ../lib/libpord*SEQ.a ../lib/libmpiseq*SEQ.a ../lib/WHERE.mumpsseq
	-rm -rf $(SRCDIR)
	-rm *.done config.log

# Local Variables:
# mode:makefile
# ispell-local-dictionary:"british"
# coding:utf-8
# End:

=== 3rdparty/nlopt/Makefile ===
URL="http://ab-initio.mit.edu/nlopt/nlopt-2.2.4.tar.gz"
SRCDIR=nlopt-2.2.4
TARGZ=../pkg/$(SRCDIR).tar.gz
-include Make.defs

all: FAIRE

FAIRE: ../pkg $(SRCDIR)/FAIT 

$(SRCDIR)/FAIT: $(TARGZ)
	tar zxf $(TARGZ)
#
#	FFCS - 30/11/11 - "--disable-dependency-tracking": dependencies pose problem on mixed Cygwin/MinGW setups
#	because of slashes and backslashes
#
# 	FFCS - 22/10/12 - Fred - "--without-octave": patch for one machine that has octave installed on it: building of
#	nlopt fails because it wants to install the octave components.  Not a bad idea in general but probably not when
#	building ffcs.
#
	#remove c++11 flags for windfows  FH ..
	cxxflags=`echo $(CXXFLAGS) |sed -e 's/[-]std=c[+][+]11//g'` ; \
	cd $(SRCDIR) && ./configure --disable-dependency-tracking --with-cxx --prefix="$(FFDOWNLOAD)" CXX="$(CXX)"	\
	CXXFLAGS="$(CXXFLAGS)" CC="$(CC)" CFLAGS="$(CFLAGS)" CPP="$$cxxflag" "--without-threadlocal" "--without-octave"
#
#	FFCS - 30/11/11 - we need to know when the building process breaks
#
	cd $(SRCDIR) && $(MAKE) install
	touch $(SRCDIR)/FAIT
	$(MAKE) WHERE
../pkg:
	mkdir $@

$(TARGZ):
	../getall -o NLopt -a

clean-local:
	rm -rf $(SRCDIR) Make.defs 
	rm -f ../lib/libnlopt_cxx*  ../lib/WHERE.nlopt 
	rm -f ../include/nlopt*

clean:clean-local

WHERE: 
	-if [ -f $(SRCDIR)/FAIT ] ; then \
	echo nlopt LD -L@DIR@/lib -lnlopt_cxx  >../lib/WHERE.nlopt ;\
	echo nlopt INCLUDE -I@DIR@/include >> ../lib/WHERE.nlopt ;\
	fi

Make.defs: ../../config.status	Makefile Make.inc
	../../config.status  --file="Make.defs:Make.inc"

=== debian/changelog ===
freefem++ (4.15+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update hardening flags.
  * Ignore unsupported LD/CPP flags from hdf5 library (Closes: #1095401)
  * Create manual page for md2edp

 -- Francois Mazen <mzf@debian.org>  Sun, 16 Feb 2025 21:22:48 +0100

=== debian/control ===
Source: freefem++
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>,
           Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>,
           Francois Mazen <mzf@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libsuperlu-dev,
               gawk,
               gfortran,
               rdfind,
               symlinks,
               libhdf5-dev,
               flex,
               bison,
               libxt-dev,
               libxext-dev,
               libxxf86vm-dev,
               libxpm-dev,
               libmumps-scotch-dev,
               libmumps-ptscotch-dev,
               libfltk1.3-dev,
               freeglut3-dev,
               ghostscript,
               imagemagick,
               texlive,
               texlive-extra-utils,
               texlive-latex-extra,
               texlive-font-utils,
               libfftw3-dev,
               libgsl-dev,
               libhypre-dev,
               libarpack2-dev,
               libsuitesparse-dev,
               libmumps-dev,
               libscalapack-mpi-dev,
               libscotch-dev,
               libptscotch-dev,
               libmetis-dev,
               libmumps-seq-dev,
               libnlopt-dev,
               coinor-libipopt-dev,
               libgmm++-dev,
               libtet1.5-dev,
               libpetsc-real-dev,
               libpetsc-complex-dev,
               unzip,
               autoconf-archive
# libmmg3dlib4.0-4.0-dev, freeyams, mshmet, mshint,
# libparms2-dev, libitsol-dev,
# libhips-dev, libpastix-dev,
# libsuperlu-dist-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/freefempp
Vcs-Git: https://salsa.debian.org/science-team/freefempp.git
Homepage: http://www.freefem.org/ff++/
Rules-Requires-Root: no

Package: freefem++
Architecture: any
Section: math
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Provides the binaries of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the executables of FreeFem++.

Package: libfreefem++
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Provides the shared libraries of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the shared libraries of FreeFem++.

Package: libfreefem++-dev
Architecture: any
Section: libdevel
Depends: libfreefem++,
         ${shlibs:Depends},
         ${misc:Depends}
Description: Provides the development files of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the development files of FreeFem++.

Package: freefem++-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Provides the documentation of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the documentation files of FreeFem++.

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//, \
    repacksuffix=+dfsg, \
    repack,compression=xz,\
    uversionmangle=s/-/./g, \
    filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/freefem\+\+-(.+)\.tar\.gz/ " \
    https://github.com/FreeFem/FreeFem-sources/tags .*/v?(\d\S+)\.tar\.gz
